* ͻ
*  Program        XBACKUP.PRG                                              
*  System         XBASE++ and Express                                      
* ͼ

#include "dcdialog.ch"
#include "dcbitmap.ch"

PROCEDURE APPSYS
* ͻ
*  Purpose        Initial stuff                                            
*  Parameters                                                              
* ͼ

RETURN


PROCEDURE APPQUIT
* ͻ
*  Purpose        Closing stuff                                            
*  Parameters                                                              
* ͼ

RETURN


PROCEDURE DBESYS
* ͻ
*  Purpose        Initial database stuff                                   
*  Parameters                                                              
* ͼ

RETURN


FUNCTION MAIN()
* ͻ
*  Purpose        Main menu                                                
* ͼ
LOCAL aPayType, GetList := {}, oBrowse, oBrowBox, oOpen_Menu

aPayType:=  {{PADR("Visa  ",30)     ,"V    "},;
             {PADR("MasterCard",30) ,"M    "},;
             {PADR("Cash",30)       ,"C    "},;
             {PADR("Account",30)    ,"A    "},;
             {PADR("Discover",30)   ,"D    "},;
             {PADR("Net-30",30)     ,"N    "},;
             {PADR("ChecK",30)      ,"K    "},;
             {PADR("Other",30)      ,"O    "}}

@ 1,2 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX ;
    OBJECT oBrowBox ;
    SIZE 30, 10

@  0.1,0.2 DCBROWSE oBrowse ;
    DATA aPayType ;
    SIZE 29.4,9.7 ;
    RBSELECT ;
    PARENT oBrowBox

DCBROWSECOL ELEMENT 1 ;
    WIDTH 10 ;
    HEADER "Description" ;
    PARENT oBrowse

DCBROWSECOL ELEMENT 2 ;
    WIDTH 8 ;
    HEADER "Code" ;
    PARENT oBrowse

DCSUBMENU oOpen_Menu ;
    PROMPT "Open Jobs" ;
    PARENT oBrowse ;
    OWNERDRAW

DCMENUITEM "Change Order FlowStatus" ;
    BITMAP BITMAP_EXECUTE_M ;
    PARENT oOpen_Menu ;
    ACTION { || .T. }

DCMENUITEM SEPARATOR ;
    PARENT oOpen_Menu

DCMENUITEM "Schedule Job Item" ;
    BITMAP BITMAP_PICKLIST ;
    PARENT oOpen_Menu ;
    ACTION { || .T. }

DCREAD GUI ;
    MODAL ;
    TITLE "Right-click for menu" ;
    BUTTONS DCGUI_BUTTON_EXIT ;
    FIT ;
    EVAL { |o| GEN_RB_ACTION( oBrowse, @oOpen_Menu, 2 ) }

RETURN .T.


FUNCTION GEN_RB_ACTION( oBrowse, oMenu, anColumns )
* ͻ
*  Description    This enables to use right mouse button in the browser    
*  Parameters                                                              
*   oBrowse       Browse object                                            
*   oMenu         Menu object                                              
*   anColumns     If numeric, number of left browse columns to attach      
*                   menu to.                                               
*                 If array, select the columns that you would like to      
*                   attach the menu to { 1,2,4,5 }                         
*                 If empty, defaults to all columns                        
*  Return Value   NIL                                                      
* ͼ
LOCAL i, oXbp, oCellGroup
LOCAL nLoop := 0

IF VALTYPE( oMenu ) == "O" .AND. oMenu:numItems() > 0

    DEFAULT anColumns := oBrowse:colCount

    IF VALTYPE( anColumns ) == "N"
        nLoop := anColumns
    ELSEIF VALTYPE( anColumns ) == "A"
        nLoop := oBrowse:colCount
    ENDIF

    FOR i := 1 TO nLoop
        IF VALTYPE( anColumns ) == "N" .OR. ;
                ASCAN( anColumns, { |a| a == i } ) > 0
            oXbp := oBrowse:getColumn(i)
            oCellGroup := oXbp:dataArea
            // Attach menu to each cellgroup
            oCellGroup:RbDown := DC_MERGEBLOCKS( oCellGroup:RbDown, ;
                { |x,y,z| oMenu:PopUp( NIL, x, 1, ;
                XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN ) } )
        ENDIF
    NEXT

ENDIF

RETURN .T.

